Redmine - Feature #6687

Making an issue a subtask leads to loss of issue-property values
2010-10-18 05:59 - Mischa The Evil

Status: New Start date: 2010-10-18
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: Candidate for next minor release

Resolution:

Description

When a normal issue is changed to being a subtask (thus getting an initial parent id) current values for the following issue-properties
are lost due to roll-up from subtasks to parent issues:

® priority

¢ start/due dates
e progress

e estimate

These changes aren't recorded to issue-journals (besides an entry about the changed parent id), thus are lost without any
reminder/notice.

Related issues:

Related to Redmine - Feature #5490: Option for independent subtask priority/s... Closed 2010-05-10
Related to Redmine - Feature #5875: Changes to child estimates should trigger... New 2010-07-12
Related to Redmine - Feature #9991: Estate parent task vs subtask Closed

Related to Redmine - Feature #13775: Adding a sub-task with zero estimated fi... Closed

Related to Redmine - Feature #27644: Journals and notifications on changes on... New

Has duplicate Redmine - Defect #14118: When creating a subtask, the priority ... Closed

Has duplicate Redmine - Defect #25056: Parent task issue Closed

History

#1 - 2010-11-08 08:21 - Ewan Makepeace

+1
At least write the values in the history so we can restore the issue as it was if needed.

#2 - 2010-12-17 06:17 - Mischa The Evil
- Priority changed from Normal to High

#3 - 2011-04-28 20:29 - Chris Wolf
- File no_priority_rollup.diff added

In my organization, we do want the dates and estimated time to rollup from the subtasks, however, we don't want the priority to rollup - we want the
priority set and maintained in the parent task independently of the subtasks. Attached is a hack to implement this. The patch includes the
cross-project subtask feature /issues/5487.

This patch is base on release 1.1.2.

#4 - 2011-04-28 20:33 - Etienne Massip

- Target version set to Candidate for next minor release

#5 - 2011-05-26 15:39 - Svein-Tore Griff With

+1
Vote for the option where the current solution is kept, but we also keep a separate estimate for the parent task, so that the parent task would have the
properties:

Estimated time: 30 hours(editable)
https://www.redmine.org/projects/redmine/wiki/Issues5487

Total estimated time from children: 32 hours

We can do the same for the other properties.

#6 - 2012-05-22 13:42 - Jacq Jacq

+1
All the properties should be editable and independent from subtasks.
As a option it could be set to get properties from subtasks.

#7 - 2012-06-06 13:44 - Radek Karban

+1

#8 - 2012-11-12 23:24 - Murray Melvin

I also would like to see something done about this. Svein-Tore Griff With's suggestion would work for me.

#9 - 2012-11-29 12:44 - Tim Hsieh

This is side effect issue made on redmine’s trunk
http://www.redmine.org/projects/redmine/repository/revisions/8382/diff/trunk/app/models/issue.rb
(Affected on Redmine v1.4.0 ~ v2.1.x.)

Solution:
http://www.redmine.org/issues/6687
This patch is workable with my production site: Redmine-v1.4.4

Related discussions:
http://www.redmine.org/issues/5490
http://www.redmine.org/issues/5875
http://www.redmine.org/issues/5880
http://www.redmine.org/boards/2/topics/19023
http://www.redmine.org/issues/6847

#10 - 2012-12-12 01:50 - Eric Voisard

All these discussions and issues about subtasks just show that this important feature needs serious (and open minded) rethinking.

Or an option to disable subtasks completely...

#11 - 2013-01-27 16:21 - Julian S. Luipold

+1
would prefer to have a per project setting for the behaviour of subtasks!

#12 - 2013-02-22 21:10 - Bishma Stornelli Ortega

- File keep_original_dates_and_estimations_on_parent_issue.diff added

I've just made a patch that works like this:

When an issue is divided in subtasks, the priority, the start/dude date and the estimated time is kept in the parent but additional fields are created to
show the calculated values of the subtasks.

The estimated time of an issue must be greater than the estimated time of the subtasks, less than the estimated time of the parent - estimated time of
siblings and if the parent has not estimated time, subtasks can't have estimated time.

The done ratio is calculated using the no calculated estimated hours of the issues. Example:

Issue 1 has 100 estimated hours

It's divided into Issue 1.1 and Issue 1.2

Issue 1.1 has an estimated hours of 40 and a done ratio of 50.
Issue 1.2 has an estimated hours of 30 and a done ratio of 100.
Then the done ratio of Issue 1 is 40*0.5 + 30*1 = 50.

Dates on subtasks are allowed to be before or after the start/due date of the parent but it's always displayed in the parent issue. Maybe I'll add a
validation to avoid this and ensure that all dates in subtasks are between the start and due date of the parent.

This patch was made for version 2.2.1 and there is not warranty it works even in this version because the development was done on an already
patched version of redmine and I'm not sure if the files edited were changed previously.

Don't forget to run the migration (it will force update of these attributes for all existing issues).
#13 - 2013-03-27 02:45 - Toshi MARUYAMA
- Tracker changed from Defect to Feature

- Priority changed from High to Normal

#14 - 2013-03-31 22:22 - VD DV

+1

#15 - 2013-04-19 17:30 - Sebastian Bertram

Hi the patch sounds realy good. Did somebody try it? | have a new installed 2.3 version of redmine here and the parent subtask thing is realy
annoying

#16 - 2013-04-19 21:53 - Sebastian Bertram

| did try to patch my redmine 2.3 today and | get an internal error when | want to display the issus. I'm glad that | patched with the backup option.

#17 - 2013-04-20 01:09 - Sebastian Bertram

Now | realize that | didn't run the migration. Could the internal error 500 occurred because of that?

#18 - 2013-04-20 01:27 - Bishma Stornelli Ortega

Hello Sebastian, | guess it is. Probably a NoMethodError. You can check the log and print the error message here.

#19 - 2013-04-20 01:54 - Sebastian Bertram

Unfortunately there was a permission issue, so the log wasn't written. But at the Moment | also think that the Problem maybe only or also comes from
the fact, that | am using redmine with German language and the patch only changes the file for the English and Spanish language.

So | think there a two things | can try now. Change the language file and make a migration.

Is there something | have to care about when | add the added lines of the en.ylm to the de.ylm? Other then translation the words after the colon.

Is there a order in which the lines have to be added?

#20 - 2013-04-20 01:58 - Bishma Stornelli Ortega

No. Just add the lines in any order but make sure you use the right indentation.

#21 - 2013-04-20 13:45 - Sebastian Bertram
- File de.yml added

Ok, now | patched the files again and also changed the de.yml. At the moment | have the problem, that the german translation isn't working for the
hole programm. And | don't know why.
Here is the file | created.

#22 - 2013-04-20 14:00 - Sebastian Bertram
- File log redmine.JPG added

And the log shows that. (see file)

#23 - 2013-07-04 21:14 - Mischa The Evil

- Related to Feature #13775: Adding a sub-task with zero estimated time erases parents value added
#24 - 2013-07-11 16:12 - Lucas Ribeiro
Bishma Stornelli Ortega wrote:

I've just made a patch that works like this:

When an issue is divided in subtasks, the priority, the start/dude date and the estimated time is kept in the parent but additional fields are created
to show the calculated values of the subtasks.

The estimated time of an issue must be greater than the estimated time of the subtasks, less than the estimated time of the parent - estimated
time of siblings and if the parent has not estimated time, subtasks can't have estimated time.

The done ratio is calculated using the no calculated estimated hours of the issues. Example:

Issue 1 has 100 estimated hours

It's divided into Issue 1.1 and Issue 1.2

Issue 1.1 has an estimated hours of 40 and a done ratio of 50.
Issue 1.2 has an estimated hours of 30 and a done ratio of 100.
e Then the done ratio of Issue 1 is 40*0.5 + 30*1 = 50.

Dates on subtasks are allowed to be before or after the start/due date of the parent but it's always displayed in the parent issue. Maybe I'll add a

validation to avoid this and ensure that all dates in subtasks are between the start and due date of the parent.

This patch was made for version 2.2.1 and there is not warranty it works even in this version because the development was done on an already

patched version of redmine and I'm not sure if the files edited were changed previously.

Don't forget to run the migration (it will force update of these attributes for all existing issues).

Applied your patch on version 2.3.1 and ran the migration. No changes were found on the parent task.

#25 - 2013-07-11 16:18 - Lucas Ribeiro

Strange, even for new tasks the patch didn't work. I'm suspecting it's a migration problem, as | try to migrate there is this warning:
WARNING: 'require 'rake/rdoctask" is deprecated. Please use 'require 'rdoc/task’ (in RDoc 2.4.2+)" instead.

Any clues?

#26 - 2015-10-11 21:11 - Sebastian Paluch

It seems that this has been already implemented by #16092 and #5490. The behavior is now configurable so probably this can be closed.
#27 - 2017-02-14 08:40 - Mischa The Evil
Sebastian Paluch wrote:

It seems that this has been already implemented by #16092 and #5490. The behavior is now configurable so probably this can be closed.

No, this issue is not-yet solved. See eg. this case (taken from #25056):
Mischa The Evil wrote:
[...] parent tasks attributes setting set to "calculated from subtasks" [...]
When you have two issues:

e issuel (priority => normal, start_date => 01-01-2017, due_date => 31-12-2017, %-done => 10 %)
e issue2 (priority => immediate, start_date => 05-01-2017, due_date => 05-03-2017, %-done => 50 %)

and now identify issue2 to be part of issue1 and as such edit issue2 to become a subtask of issue1, looking as follows:
¢ issue2 (priority => immediate, start_date => 05-01-2017, due_date => 05-03-2017, %-done => 50 %, parent => issue1)

then issue1 will be changed to look like following without any journal on issue1 to record the previous values of priority, start-/due date and
%-done attributes (estimated time attribute is already fixed by r14272):

e issuel (priority => immediate, start_date => 05-01-2017, due_date => 05-03-2017, %-done => 50 %)

This shows that the conversion of root-issue to parent-issue leads to a silent loss of issue attribute values, which | think is a true problem.

#28 - 2017-02-15 07:15 - Mischa The Evil
- Has duplicate Defect #25056: Parent task issue added

#29 - 2017-11-26 11:06 - Eva Encabo

+1 It's very important for us that the changes are recorded in journals and also to have notification of parent changes

#30 - 2017-11-30 02:55 - Mischa The Evil

- Related to Feature #27644: Journals and notifications on changes on Issues set by relations added

Files

no_priority_rollup.diff 2.76 KB 2011-04-28 Chris Wolf

keep_original_dates_and_estimations_on_parent_issue.diff 13.5KB 2013-02-22 Bishma Stornelli Ortega

de.yml 50.6 KB 2013-04-20 Sebastian Bertram

log redmine.JPG 61.6 KB 2013-04-20 Sebastian Bertram
2025-07-09 4/4


https://www.redmine.org/issues/16092
https://www.redmine.org/issues/5490
https://www.redmine.org/issues/16092
https://www.redmine.org/issues/5490
https://www.redmine.org/issues/25056
https://www.redmine.org/projects/redmine/repository/svn/revisions/14272
http://www.tcpdf.org

